diff --git a/lib/app/modules/petugas_desa/views/konfirmasi_penerima_page.dart b/lib/app/modules/petugas_desa/views/konfirmasi_penerima_page.dart
index 755d55d..3d86bae 100644
--- a/lib/app/modules/petugas_desa/views/konfirmasi_penerima_page.dart
+++ b/lib/app/modules/petugas_desa/views/konfirmasi_penerima_page.dart
@@ -1,7 +1,6 @@
 import 'package:flutter/material.dart';
 import 'package:get/get.dart';
 import 'package:penyaluran_app/app/data/models/penerima_penyaluran_model.dart';
-import 'package:penyaluran_app/app/data/models/bentuk_bantuan_model.dart';
 import 'package:penyaluran_app/app/modules/petugas_desa/controllers/detail_penyaluran_controller.dart';
 import 'package:penyaluran_app/app/theme/app_theme.dart';
 import 'package:image_picker/image_picker.dart';
@@ -11,16 +10,12 @@ import 'dart:typed_data';
 import 'package:penyaluran_app/app/utils/format_helper.dart';
 
 class KonfirmasiPenerimaPage extends StatefulWidget {
-  final PenerimaPenyaluranModel penerima;
-  final BentukBantuanModel? bentukBantuan;
-  final String? jumlahBantuan;
+  final String penerimaPenyaluranId;
   final DateTime? tanggalPenyaluran;
 
   const KonfirmasiPenerimaPage({
     super.key,
-    required this.penerima,
-    this.bentukBantuan,
-    this.jumlahBantuan,
+    required this.penerimaPenyaluranId,
     this.tanggalPenyaluran,
   });
 
@@ -29,13 +24,14 @@ class KonfirmasiPenerimaPage extends StatefulWidget {
 }
 
 class _KonfirmasiPenerimaPageState extends State<KonfirmasiPenerimaPage> {
-  late PenerimaPenyaluranModel penerima;
+  PenerimaPenyaluranModel? penerima;
   final controller = Get.find<DetailPenyaluranController>();
   final ImagePicker _picker = ImagePicker();
   File? _buktiPenerimaan;
   bool _setujuPenerimaan = false;
   bool _setujuPenggunaan = false;
   bool _isLoading = false;
+  bool _isDataLoading = true; // Loading state untuk data
 
   // Controller untuk tanda tangan
   final SignatureController _signatureController = SignatureController(
@@ -50,11 +46,44 @@ class _KonfirmasiPenerimaPageState extends State<KonfirmasiPenerimaPage> {
   @override
   void initState() {
     super.initState();
-    // Menggunakan data penerima yang diberikan dari arguments
-    penerima = widget.penerima;
-    print('KonfirmasiPenerimaPage - ID Penerima: ${penerima.id}');
-    print(
-        'KonfirmasiPenerimaPage - Nama Penerima: ${penerima.warga?['nama_lengkap']}');
+    // Mengambil data penerima berdasarkan ID
+    _loadPenerimaPenyaluranData();
+  }
+
+  // Fungsi untuk mengambil data penerima dari database
+  Future<void> _loadPenerimaPenyaluranData() async {
+    setState(() {
+      _isDataLoading = true;
+    });
+
+    try {
+      // Ambil data penerima beserta relasinya menggunakan ID
+      penerima = await controller
+          .getPenerimaPenyaluranById(widget.penerimaPenyaluranId);
+
+      if (penerima != null) {
+        print('KonfirmasiPenerimaPage - ID Penerima: ${penerima!.id}');
+        print(
+            'KonfirmasiPenerimaPage - Nama Penerima: ${penerima!.warga?['nama_lengkap']}');
+
+        // Jika penerima memiliki penyaluran_bantuan_id, ambil detail penyaluran
+        if (penerima!.penyaluranBantuanId != null) {
+          await controller.getDetailPenyaluran(penerima!.penyaluranBantuanId!);
+        }
+      }
+    } catch (e) {
+      print('Error saat mengambil data penerima: $e');
+      Get.snackbar(
+        'Error',
+        'Gagal memuat data penerima, silakan coba lagi',
+        backgroundColor: Colors.red,
+        colorText: Colors.white,
+      );
+    } finally {
+      setState(() {
+        _isDataLoading = false;
+      });
+    }
   }
 
   @override
@@ -66,46 +95,109 @@ class _KonfirmasiPenerimaPageState extends State<KonfirmasiPenerimaPage> {
 
   @override
   Widget build(BuildContext context) {
-    final warga = penerima.warga;
+    // Jika data masih loading atau penerima null, tampilkan loading indicator
+    if (_isDataLoading || penerima == null) {
+      return Scaffold(
+        appBar: AppBar(
+          title: const Text('Konfirmasi Penerimaan'),
+          centerTitle: true,
+          elevation: 0,
+          backgroundColor: AppTheme.primaryColor,
+          foregroundColor: Colors.white,
+        ),
+        body: const Center(
+          child: Column(
+            mainAxisAlignment: MainAxisAlignment.center,
+            children: [
+              CircularProgressIndicator(color: AppTheme.primaryColor),
+              SizedBox(height: 16),
+              Text(
+                'Memuat data penerimaan...',
+                style: TextStyle(
+                  fontWeight: FontWeight.w500,
+                  color: AppTheme.primaryColor,
+                ),
+              ),
+            ],
+          ),
+        ),
+      );
+    }
+
+    final warga = penerima!.warga;
 
     return Scaffold(
       appBar: AppBar(
-        title: const Text('Form Konfirmasi Penerimaan Bantuan'),
+        title: const Text('Konfirmasi Penerimaan'),
         centerTitle: true,
+        elevation: 0,
+        backgroundColor: AppTheme.primaryColor,
+        foregroundColor: Colors.white,
         leading: IconButton(
           icon: const Icon(Icons.arrow_back),
           onPressed: () => Get.back(),
         ),
+        shape: const RoundedRectangleBorder(
+          borderRadius: BorderRadius.vertical(
+            bottom: Radius.circular(16),
+          ),
+        ),
       ),
       body: _isLoading
           ? const Center(
               child: Column(
                 mainAxisAlignment: MainAxisAlignment.center,
                 children: [
-                  CircularProgressIndicator(),
+                  CircularProgressIndicator(color: AppTheme.primaryColor),
                   SizedBox(height: 16),
-                  Text('Sedang memproses konfirmasi...'),
+                  Text(
+                    'Sedang memproses konfirmasi...',
+                    style: TextStyle(
+                      fontWeight: FontWeight.w500,
+                      color: AppTheme.primaryColor,
+                    ),
+                  ),
                 ],
               ),
             )
-          : SingleChildScrollView(
-              child: Padding(
-                padding: const EdgeInsets.all(16.0),
-                child: Column(
-                  crossAxisAlignment: CrossAxisAlignment.start,
-                  children: [
-                    _buildDetailPenerimaSection(warga),
-                    const SizedBox(height: 16),
-                    _buildDetailBantuanSection(),
-                    const SizedBox(height: 16),
-                    _buildFotoBuktiSection(),
-                    const SizedBox(height: 16),
-                    _buildTandaTanganSection(),
-                    const SizedBox(height: 16),
-                    _buildFormPersetujuanSection(),
-                    const SizedBox(height: 24),
-                    _buildKonfirmasiButton(),
-                  ],
+          : Container(
+              color: Colors.grey[50],
+              child: SingleChildScrollView(
+                child: Padding(
+                  padding: const EdgeInsets.all(16.0),
+                  child: Column(
+                    crossAxisAlignment: CrossAxisAlignment.start,
+                    children: [
+                      Text(
+                        'Form Konfirmasi Penerimaan Bantuan',
+                        style: TextStyle(
+                          fontSize: 18,
+                          fontWeight: FontWeight.bold,
+                          color: AppTheme.primaryColor,
+                        ),
+                      ),
+                      const SizedBox(height: 4),
+                      Text(
+                        'Silahkan isi data-data berikut untuk mengkonfirmasi penerimaan bantuan',
+                        style: TextStyle(
+                          fontSize: 14,
+                          color: Colors.grey[600],
+                        ),
+                      ),
+                      const SizedBox(height: 24),
+                      _buildDetailPenerimaSection(warga),
+                      const SizedBox(height: 16),
+                      _buildDetailBantuanSection(),
+                      const SizedBox(height: 16),
+                      _buildFotoBuktiSection(),
+                      const SizedBox(height: 16),
+                      _buildTandaTanganSection(),
+                      const SizedBox(height: 16),
+                      _buildFormPersetujuanSection(),
+                      const SizedBox(height: 24),
+                      _buildKonfirmasiButton(),
+                    ],
+                  ),
                 ),
               ),
             ),
@@ -123,151 +215,343 @@ class _KonfirmasiPenerimaPageState extends State<KonfirmasiPenerimaPage> {
         child: Column(
           crossAxisAlignment: CrossAxisAlignment.start,
           children: [
-            const Text(
-              'Detail Penerima',
-              style: TextStyle(
-                fontSize: 18,
-                fontWeight: FontWeight.bold,
-                color: AppTheme.primaryColor,
-              ),
-            ),
-            const SizedBox(height: 16),
-
-            // Foto Identitas
             Row(
-              crossAxisAlignment: CrossAxisAlignment.start,
               children: [
-                const Text(
-                  'Foto Identitas',
-                  style: TextStyle(
-                    fontWeight: FontWeight.w500,
+                Container(
+                  padding: const EdgeInsets.all(8),
+                  decoration: BoxDecoration(
+                    color: AppTheme.primaryColor.withOpacity(0.1),
+                    borderRadius: BorderRadius.circular(8),
+                  ),
+                  child: const Icon(
+                    Icons.person_outline,
+                    color: AppTheme.primaryColor,
                   ),
                 ),
-                const Spacer(),
-                Container(
-                  width: 60,
-                  height: 80,
-                  decoration: BoxDecoration(
-                    color: Colors.grey[200],
-                    borderRadius: BorderRadius.circular(8),
-                    image: warga?['foto_identitas'] != null
-                        ? DecorationImage(
-                            image: NetworkImage(warga!['foto_identitas']),
-                            fit: BoxFit.cover,
-                          )
-                        : null,
+                const SizedBox(width: 12),
+                const Text(
+                  'Detail Penerima',
+                  style: TextStyle(
+                    fontSize: 18,
+                    fontWeight: FontWeight.bold,
+                    color: AppTheme.primaryColor,
                   ),
-                  child: warga?['foto_identitas'] == null
-                      ? const Icon(Icons.person, color: Colors.grey)
-                      : null,
                 ),
               ],
             ),
+            const SizedBox(height: 16),
             const Divider(),
 
-            //nama lengkap
-            _buildInfoRow('Nama Lengkap', warga?['nama_lengkap'] ?? 'Bajiyadi'),
-
-            // NIK
-            _buildInfoRow('NIK', warga?['nik'] ?? '3201020107030010'),
+            // Foto & Identitas Utama
+            Padding(
+              padding: const EdgeInsets.symmetric(vertical: 8),
+              child: Row(
+                crossAxisAlignment: CrossAxisAlignment.start,
+                children: [
+                  // Foto identitas
+                  Container(
+                    width: 80,
+                    height: 100,
+                    decoration: BoxDecoration(
+                      color: Colors.grey[200],
+                      borderRadius: BorderRadius.circular(8),
+                      border: Border.all(color: Colors.grey[300]!),
+                      image: warga?['foto_profil'] != null
+                          ? DecorationImage(
+                              image: NetworkImage(warga!['foto_profil']),
+                              fit: BoxFit.cover,
+                            )
+                          : null,
+                    ),
+                    child: warga?['foto_profil'] == null
+                        ? Icon(Icons.person, color: Colors.grey[400], size: 40)
+                        : null,
+                  ),
+                  const SizedBox(width: 16),
+                  // Informasi identitas utama
+                  Expanded(
+                    child: Column(
+                      crossAxisAlignment: CrossAxisAlignment.start,
+                      children: [
+                        Text(
+                          warga?['nama_lengkap'] ?? 'Bajiyadi',
+                          style: const TextStyle(
+                            fontSize: 16,
+                            fontWeight: FontWeight.bold,
+                            color: Colors.black87,
+                          ),
+                        ),
+                        const SizedBox(height: 4),
+                        _buildKeyValueText(
+                            'NIK', warga?['nik'] ?? '3201020107030010'),
+                        const SizedBox(height: 4),
+                        _buildKeyValueText(
+                            'No KK', warga?['no_kk'] ?? '3201020107030393'),
+                        const SizedBox(height: 4),
+                        _buildKeyValueText(
+                            'Telepon', warga?['no_telepon'] ?? '089891256532'),
+                      ],
+                    ),
+                  ),
+                ],
+              ),
+            ),
             const Divider(),
 
-            // No KK
-            _buildInfoRow('No KK', warga?['no_kk'] ?? '3201020107030393'),
-            const Divider(),
+            // Informasi Personal
+            Container(
+              padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 12),
+              decoration: BoxDecoration(
+                color: Colors.blue[50],
+                borderRadius: BorderRadius.circular(8),
+              ),
+              child: Column(
+                crossAxisAlignment: CrossAxisAlignment.start,
+                children: [
+                  const Text(
+                    'Informasi Personal',
+                    style: TextStyle(
+                      fontWeight: FontWeight.bold,
+                      color: Colors.blue,
+                    ),
+                  ),
+                  const SizedBox(height: 8),
+                  Row(
+                    children: [
+                      Expanded(
+                        child: _buildInfoItem(
+                          icon: Icons.wc_outlined,
+                          title: 'Jenis Kelamin',
+                          value: warga?['jenis_kelamin'] ?? 'Pria',
+                        ),
+                      ),
+                      Expanded(
+                        child: _buildInfoItem(
+                          icon: Icons.bookmark_outlined,
+                          title: 'Agama',
+                          value: warga?['agama'] ?? 'Islam',
+                        ),
+                      ),
+                    ],
+                  ),
+                  const SizedBox(height: 8),
+                  _buildInfoItem(
+                    icon: Icons.cake_outlined,
+                    title: 'Tempat, Tanggal Lahir',
+                    value: warga?['tempat_lahir'] != null &&
+                            warga?['tanggal_lahir'] != null
+                        ? '${warga!['tempat_lahir']}, ${FormatHelper.formatDateTime(DateTime.parse(warga['tanggal_lahir']), format: 'd MMMM yyyy')}'
+                        : 'Bogor, 2 Juni 1990',
+                  ),
+                ],
+              ),
+            ),
+            const SizedBox(height: 12),
 
-            // No Handphone
-            _buildInfoRow(
-                'No Handphone', warga?['no_telepon'] ?? '089891256532'),
-            const Divider(),
+            // Alamat
+            _buildDetailItem(
+              icon: Icons.home_outlined,
+              title: 'Alamat',
+              value: warga?['alamat'] ??
+                  'Jl. Letda Natsir No. 22 RT 001/003\nKec. Gunung Putri Kab. Bogor',
+              color: Colors.green,
+            ),
+
+            const SizedBox(height: 12),
+
+            // Pekerjaan & Pendidikan
+            _buildDetailItem(
+              icon: Icons.work_outline,
+              title: 'Pekerjaan',
+              value: warga?['pekerjaan'] ?? 'Petani',
+              color: Colors.orange,
+            ),
+            const SizedBox(height: 12),
+            _buildDetailItem(
+              icon: Icons.school_outlined,
+              title: 'Pendidikan',
+              value: warga?['pendidikan_terakhir'] ?? 'Sekolah Dasar (SD)',
+              color: Colors.purple,
+            ),
+            const SizedBox(height: 12),
 
             // Email
-            _buildInfoRow('Email', warga?['email'] ?? 'bajiyadi@gmail.com'),
-            const Divider(),
-
-            // Jenis Kelamin
-            _buildInfoRow('Jenis Kelamin', warga?['jenis_kelamin'] ?? 'Pria'),
-            const Divider(),
-
-            // Agama
-            _buildInfoRow('Agama', warga?['agama'] ?? 'Islam'),
-            const Divider(),
-
-            // Tempat, Tanggal Lahir
-            _buildInfoRow(
-                'Tempat, Tanggal Lahir',
-                warga?['tempat_lahir'] != null &&
-                        warga?['tanggal_lahir'] != null
-                    ? '${warga!['tempat_lahir']}, ${FormatHelper.formatDateTime(DateTime.parse(warga['tanggal_lahir']), format: 'd MMMM yyyy')}'
-                    : 'Bogor, 2 Juni 1990'),
-            const Divider(),
-
-            // Alamat Lengkap
-            _buildInfoRow(
-                'Alamat Lengkap',
-                warga?['alamat'] ??
-                    'Jl. Letda Natsir No. 22 RT 001/003\nKec. Gunung Putri Kab. Bogor'),
-            const Divider(),
-
-            // Pekerjaan
-            _buildInfoRow('Pekerjaan', warga?['pekerjaan'] ?? 'Petani'),
-            const Divider(),
-
-            // Pendidikan Terakhir
-            _buildInfoRow('Pendidikan Terakhir',
-                warga?['pendidikan_terakhir'] ?? 'Sekolah Dasar (SD)'),
+            _buildDetailItem(
+              icon: Icons.email_outlined,
+              title: 'Email',
+              value: warga?['email'] ?? 'bajiyadi@gmail.com',
+              color: Colors.red,
+            ),
           ],
         ),
       ),
     );
   }
 
+  Widget _buildKeyValueText(String key, String value) {
+    return Row(
+      children: [
+        Text(
+          '$key: ',
+          style: TextStyle(
+            fontSize: 13,
+            color: Colors.grey[600],
+          ),
+        ),
+        Expanded(
+          child: Text(
+            value,
+            style: const TextStyle(
+              fontSize: 13,
+              fontWeight: FontWeight.w500,
+            ),
+            overflow: TextOverflow.ellipsis,
+          ),
+        ),
+      ],
+    );
+  }
+
+  Widget _buildInfoItem({
+    required IconData icon,
+    required String title,
+    required String value,
+  }) {
+    return Row(
+      crossAxisAlignment: CrossAxisAlignment.start,
+      children: [
+        Icon(icon, size: 16, color: Colors.blue[700]),
+        const SizedBox(width: 4),
+        Expanded(
+          child: Column(
+            crossAxisAlignment: CrossAxisAlignment.start,
+            children: [
+              Text(
+                title,
+                style: TextStyle(
+                  fontSize: 12,
+                  color: Colors.grey[600],
+                ),
+              ),
+              Text(
+                value,
+                style: const TextStyle(
+                  fontSize: 13,
+                  fontWeight: FontWeight.w500,
+                ),
+              ),
+            ],
+          ),
+        ),
+      ],
+    );
+  }
+
+  Widget _buildDetailItem({
+    required IconData icon,
+    required String title,
+    required String value,
+    required Color color,
+  }) {
+    return Container(
+      padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 12),
+      decoration: BoxDecoration(
+        color: color.withOpacity(0.1),
+        borderRadius: BorderRadius.circular(8),
+      ),
+      child: Row(
+        crossAxisAlignment: CrossAxisAlignment.start,
+        children: [
+          Icon(icon, size: 20, color: color),
+          const SizedBox(width: 8),
+          Expanded(
+            child: Column(
+              crossAxisAlignment: CrossAxisAlignment.start,
+              children: [
+                Text(
+                  title,
+                  style: TextStyle(
+                    fontWeight: FontWeight.bold,
+                    color: color,
+                    fontSize: 13,
+                  ),
+                ),
+                const SizedBox(height: 2),
+                Text(
+                  value,
+                  style: const TextStyle(
+                    fontSize: 13,
+                  ),
+                ),
+              ],
+            ),
+          ),
+        ],
+      ),
+    );
+  }
+
   Widget _buildDetailBantuanSection() {
-    // Tentukan satuan berdasarkan data yang tersedia
+    // Tentukan satuan dan apakah bantuan berupa uang
     String satuan = '';
-    if (widget.bentukBantuan?.satuan != null) {
-      satuan = widget.bentukBantuan!.satuan!;
-    } else if (penerima.satuan != null) {
-      satuan = penerima.satuan!;
+    bool isUang = false;
+
+    // Ambil dari stok_bantuan jika tersedia (prioritas utama)
+    if (penerima!.stokBantuan != null &&
+        penerima!.stokBantuan!['satuan'] != null) {
+      satuan = penerima!.stokBantuan!['satuan'];
+      // Cek apakah bantuan berupa uang dari stok_bantuan
+      isUang = penerima!.stokBantuan!['is_uang'] ?? false;
+    } else if (penerima!.satuan != null) {
+      // Ambil dari property satuan di model (sudah diambil dari relasi dalam fromJson)
+      satuan = penerima!.satuan!;
+      isUang = penerima!.isUang ?? false;
     } else {
-      // Default satuan jika tidak ada
-      satuan = 'Kg';
+      // Default jika tidak ada informasi satuan
+      satuan = 'buah';
+      isUang = false;
     }
 
+    // Tentukan tanggal dan waktu penyaluran
     String tanggalWaktuPenyaluran = '';
     if (widget.tanggalPenyaluran != null) {
       final tanggal = FormatHelper.formatDateTime(widget.tanggalPenyaluran!);
-      final waktuMulai = FormatHelper.formatTime(widget.tanggalPenyaluran!);
-      final waktuSelesai = FormatHelper.formatTime(
-          widget.tanggalPenyaluran!.add(const Duration(hours: 1)));
-      tanggalWaktuPenyaluran = '$tanggal $waktuMulai-$waktuSelesai';
-    } else if (penerima.penyaluranBantuan != null &&
-        penerima.penyaluranBantuan!['tanggal_penyaluran'] != null) {
+      tanggalWaktuPenyaluran = tanggal;
+    } else if (penerima!.penyaluranBantuan != null &&
+        penerima!.penyaluranBantuan!['tanggal_penyaluran'] != null) {
       final tanggalPenyaluran =
-          DateTime.parse(penerima.penyaluranBantuan!['tanggal_penyaluran']);
+          DateTime.parse(penerima!.penyaluranBantuan!['tanggal_penyaluran']);
+
       final tanggal = FormatHelper.formatDateTime(tanggalPenyaluran);
-      final waktuMulai = FormatHelper.formatTime(tanggalPenyaluran);
-      final waktuSelesai = FormatHelper.formatTime(
-          tanggalPenyaluran.add(const Duration(hours: 1)));
-      tanggalWaktuPenyaluran = '$tanggal $waktuMulai-$waktuSelesai';
+
+      tanggalWaktuPenyaluran = tanggal;
     } else {
-      tanggalWaktuPenyaluran = '09 April 2025 13:00-14:00';
+      tanggalWaktuPenyaluran = 'Belum terjadwal';
     }
 
     // Ambil nama bantuan dari model jika tersedia
-    String namaBantuan = 'Beras';
-    if (widget.bentukBantuan?.nama != null) {
-      namaBantuan = widget.bentukBantuan!.nama!;
-    } else if (penerima.kategoriNama != null) {
-      namaBantuan = penerima.kategoriNama!;
+    String namaBantuan = '';
+    if (penerima!.stokBantuan != null &&
+        penerima!.stokBantuan!['nama'] != null) {
+      // Ambil dari stok_bantuan (prioritas utama)
+      namaBantuan = penerima!.stokBantuan!['nama'];
+    } else if (penerima!.kategoriNama != null &&
+        penerima!.kategoriNama!.isNotEmpty) {
+      namaBantuan = penerima!.kategoriNama!;
+    } else if (penerima!.penyaluranBantuan?['kategori']?['nama'] != null) {
+      namaBantuan = penerima!.penyaluranBantuan!['kategori']['nama'];
+    } else {
+      namaBantuan = '';
     }
 
-    // Ambil jumlah bantuan
-    String jumlahBantuan = '5';
-    if (widget.jumlahBantuan != null) {
-      jumlahBantuan = widget.jumlahBantuan!;
-    } else if (penerima.jumlahBantuan != null) {
-      jumlahBantuan = penerima.jumlahBantuan.toString();
+    // Ambil jumlah bantuan dari property jumlahBantuan di model
+    String jumlahBantuan = '';
+    if (penerima!.jumlahBantuan != null) {
+      jumlahBantuan = penerima!.jumlahBantuan.toString();
+    } else if (penerima!.penyaluranBantuan?['jumlah'] != null) {
+      jumlahBantuan = penerima!.penyaluranBantuan!['jumlah'].toString();
+    } else {
+      jumlahBantuan = '1';
     }
 
     return Card(
